---
title: Grid
layout: home
---

# Grid
A simple 12 column grid built using flexbox.
{: .lead }

<div class="row">
  <div class="column -xs-12">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-1">
    <div class="box"></div>
  </div>
  <div class="column -xs-11">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-2">
    <div class="box"></div>
  </div>
  <div class="column -xs-10">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-9">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-4">
    <div class="box"></div>
  </div>
  <div class="column -xs-8">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-5">
    <div class="box"></div>
  </div>
  <div class="column -xs-7">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-6">
    <div class="box"></div>
  </div>
  <div class="column -xs-6">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-7">
    <div class="box"></div>
  </div>
  <div class="column -xs-5">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-8">
    <div class="box"></div>
  </div>
  <div class="column -xs-4">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-9">
    <div class="box"></div>
  </div>
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-10">
    <div class="box"></div>
  </div>
  <div class="column -xs-2">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-11">
    <div class="box"></div>
  </div>
  <div class="column -xs-1">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-12">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-3"></div>
    <div class="column -xs-9"></div>
  </div>
</div>
~~~


## Grid Offset
Grid offsets are used to move a column to the right without creating an empty column next to it.

<div class="row">
  <div class="column -xs-12">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-11 -offset-xs-1">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-10 -offset-xs-2">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-9 -offset-xs-3">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-8 -offset-xs-4">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-7 -offset-xs-5">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-6 -offset-xs-6">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-5 -offset-xs-7">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-4 -offset-xs-8">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-3 -offset-xs-9">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-2 -offset-xs-10">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-1 -offset-xs-11">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-1 -offset-xs-11"></div>
  </div>
</div>
~~~


## Grid Push / Pull
Code-wise, the columns have a different order.

<div class="row">
  <div class="column -xs-12"></div>
</div>
<div class="row">
  <div class="column -xs-1 -push-xs-11">
    <div class="box"></div>
  </div>
  <div class="column -xs-11 -pull-xs-1">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-2 -push-xs-10">
    <div class="box"></div>
  </div>
  <div class="column -xs-10 -pull-xs-2">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-3 -push-xs-9">
    <div class="box"></div>
  </div>
  <div class="column -xs-9 -pull-xs-3">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-4 -push-xs-8">
    <div class="box"></div>
  </div>
  <div class="column -xs-8 -pull-xs-4">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-5 -push-xs-7">
    <div class="box"></div>
  </div>
  <div class="column -xs-7 -pull-xs-5">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-6 -push-xs-6">
    <div class="box"></div>
  </div>
  <div class="column -xs-6 -pull-xs-6">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-7 -push-xs-5">
    <div class="box"></div>
  </div>
  <div class="column -xs-5 -pull-xs-7">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-8 -push-xs-4">
    <div class="box"></div>
  </div>
  <div class="column -xs-4 -pull-xs-8">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-9 -push-xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-3 -pull-xs-9">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-10 -push-xs-2">
    <div class="box"></div>
  </div>
  <div class="column -xs-2 -pull-xs-10">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-11 -push-xs-1">
    <div class="box"></div>
  </div>
  <div class="column -xs-1 -pull-xs-11">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs-12">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-4 -xs-push-8"></div>
    <div class="column -xs-8 -xs-pull-4"></div>
  </div>
</div>
~~~


## Auto Width
The grid will automatically fit any number of auto sizing columns to a row.

<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>
<div class="row">
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
  <div class="column -xs">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column"></div>
    <div class="column"></div>
    <div class="column"></div>
  </div>
</div>
~~~


## Nested Grid
The grid will automatically fit any number of auto sizing columns to a row.

<div class="row">
  <div class="column -xs-8">
    <div class="row">
      <div class="column -xs-3">
        <div class="box"></div>
      </div>
      <div class="column -xs-3">
        <div class="box"></div>
      </div>
      <div class="column -xs-3">
        <div class="box"></div>
      </div>
      <div class="column -xs-3">
        <div class="box"></div>
      </div>
    </div>
  </div>
  <div class="column -xs-4">
    <div class="row">
      <div class="column -xs-6">
        <div class="box"></div>
      </div>
      <div class="column -xs-6">
        <div class="box"></div>
      </div>
    </div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-8">
      <div class="column -xs-3"></div>
      <div class="column -xs-3"></div>
      <div class="column -xs-3"></div>
      <div class="column -xs-3"></div>
    </div>
    <div class="column -xs-4">
      <div class="column -xs-6"></div>
      <div class="column -xs-6"></div>
    </div>
  </div>
</div>
~~~


## Horizontal Alignment
Align elements to the start, center, or end of a row.

### .-start-*

<div class="row -start-xs">
  <div class="column -xs-4">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -start-xs">
    <div class="column -xs-4"></div>
  </div>
</div>
~~~

### .-center-*

<div class="row -center-xs">
  <div class="column -xs-4">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -center-xs">
    <div class="column -xs-4"></div>
  </div>
</div>
~~~

### .-end-*

<div class="row -end-xs">
  <div class="column -xs-4">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -end-xs">
    <div class="column -xs-4"></div>
  </div>
</div>
~~~


## Vertical Alignment
Align elements to the top, bottom, or center of a column.

### .-top-*

<div class="row -top-xs">
  <div class="column -xs-6">
    <div class="box -tall"></div>
  </div>
  <div class="column -xs-6">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -top-xs">
    <div class="column -xs-6"></div>
    <div class="column -xs-6"></div>
  </div>
</div>
~~~

### .-middle-*

<div class="row -middle-xs">
  <div class="column -xs-6">
    <div class="box -tall"></div>
  </div>
  <div class="column -xs-6">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -middle-xs">
    <div class="column -xs-6"></div>
    <div class="column -xs-6"></div>
  </div>
</div>
~~~

### .-bottom-*

<div class="row -bottom-xs">
  <div class="column -xs-6">
    <div class="box -tall"></div>
  </div>
  <div class="column -xs-6">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -bottom-xs">
    <div class="column -xs-6"></div>
    <div class="column -xs-6"></div>
  </div>
</div>
~~~


## Distribution
Distribute the contents of a row or column.

### .-around-*

<div class="row -around-xs">
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -around-xs">
    <div class="column -xs-3"></div>
    <div class="column -xs-3"></div>
    <div class="column -xs-3"></div>
  </div>
</div>
~~~

### .-between-*

<div class="row -between-xs">
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
  <div class="column -xs-3">
    <div class="box"></div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -between-xs">
    <div class="column -xs-3"></div>
    <div class="column -xs-3"></div>
    <div class="column -xs-3"></div>
  </div>
</div>
~~~


## Reordering
Reorder columns using helper classes.

### .-reverse-*

<div class="row -reverse-xs">
  <div class="column -xs-3">
    <div class="box">1</div>
  </div>
  <div class="column -xs-3">
    <div class="box">2</div>
  </div>
  <div class="column -xs-3">
    <div class="box">3</div>
  </div>
  <div class="column -xs-3">
    <div class="box">4</div>
  </div>
</div>

~~~
<div class="container">
  <div class="row -reverse-xs">
    <div class="column -xs-3">1</div>
    <div class="column -xs-3">2</div>
    <div class="column -xs-3">3</div>
    <div class="column -xs-3">4</div>
  </div>
</div>
~~~

### .-first-*

<div class="row">
  <div class="column -xs-3">
    <div class="box">1</div>
  </div>
  <div class="column -xs-3">
    <div class="box">2</div>
  </div>
  <div class="column -xs-3">
    <div class="box">3</div>
  </div>
  <div class="column -xs-3 -first-xs">
    <div class="box">4</div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-3">1</div>
    <div class="column -xs-3">2</div>
    <div class="column -xs-3">3</div>
    <div class="column -xs-3 -first-xs">4</div>
  </div>
</div>
~~~

### .-last-*

<div class="row">
  <div class="column -xs-3 -last-xs">
    <div class="box">1</div>
  </div>
  <div class="column -xs-3">
    <div class="box">2</div>
  </div>
  <div class="column -xs-3">
    <div class="box">3</div>
  </div>
  <div class="column -xs-3">
    <div class="box">4</div>
  </div>
</div>

~~~
<div class="container">
  <div class="row">
    <div class="column -xs-3 -last-xs">1</div>
    <div class="column -xs-3">2</div>
    <div class="column -xs-3">3</div>
    <div class="column -xs-3">4</div>
  </div>
</div>
~~~
