module.exports = ($, gulp, config, task) => {
  const child = require('child_process');
  const logger = (buffer) => {
    buffer.toString()
      .split(/\n/)
      .forEach((message) => $.util.log('Jekyll: ' + message));
  };

  return () => {
    const args = ['serve', '--watch', '--incremental', '--drafts'];

    if (/^win/.test(process.platform)) {
      const jekyll = child.spawn('cmd', ['/s', '/c', 'jekyll'].concat(args), {
        stdio: [null, process.stdout, process.stderr],
        cwd: config.paths.docs
      });
    } else {
      const jekyll = child.spawn('jekyll', args, {
        cwd: config.paths.docs
      });

      jekyll.stdout.on('data', logger);
      jekyll.stderr.on('data', logger);
    }
  };
}
